'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

require('./config-provider');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AvAnalyticsProvider = function () {
  function AvAnalyticsProvider(avAnalyticsConfigProvider) {
    _classCallCheck(this, AvAnalyticsProvider);

    this.av = { avAnalyticsConfigProvider: avAnalyticsConfigProvider };
    this.plugins = [];
    this.virtualPageTracking = this.av.avAnalyticsConfigProvider.get().VIRTUAL_PAGE_TRACKING;
    this.appId;
    this.plugins;
  }

  _createClass(AvAnalyticsProvider, [{
    key: 'registerPlugins',
    value: function registerPlugins(_plugins) {

      if (_angular2.default.isString(_plugins)) {
        this.plugins = [_plugins];
      } else if (Array.isArray(_plugins)) {
        this.plugins = _plugins;
      } else {
        throw new Error('AvAnalytics.registerPlugins() expects a string or an array.');
      }

      return this.plugins;
    }
  }, {
    key: 'setVirtualPageTracking',
    value: function setVirtualPageTracking(value) {
      if (arguments.length) {
        this.virtualPageTracking = !!value;
      }
    }
  }, {
    key: 'isVirtualPageTracking',
    value: function isVirtualPageTracking() {
      return this.virtualPageTracking;
    }
  }, {
    key: 'setAppID',
    value: function setAppID(id) {
      this.appId = id;
      return this.appId;
    }
  }, {
    key: '$get',
    value: function $get($injector, $q, $log, $rootScope, $location, avAnalyticsConfig) {

      var self = this;

      var AvAnalytics = function () {
        function AvAnalytics() {
          var _this = this;

          _classCallCheck(this, AvAnalytics);

          this.services = {};

          if (!self.plugins || self.plugins.length === 0) {
            self.plugins = [avAnalyticsConfig.SERVICES.SPLUNK];
          }

          _angular2.default.forEach(self.plugins, function (plugin) {

            try {
              _this.services[plugin] = $injector.get(plugin);
            } catch (err) {
              $log.error('Could not load ' + plugin + ' plugin');
            }
          });
        }

        _createClass(AvAnalytics, [{
          key: 'init',
          value: function init() {
            var _this2 = this;

            if (this.isVirtualPageTracking()) {

              $rootScope.$on(avAnalyticsConfig.EVENTS.PAGE, function () {
                _this2.trackPageView($location.absUrl());
              });
            }

            _angular2.default.forEach(this.services, function (handler) {

              if (handler.isEnabled() && handler.init) {
                handler.init();
              }
            });
          }
        }, {
          key: 'trackEvent',
          value: function trackEvent(properties) {

            var promises = [];

            _angular2.default.forEach(this.services, function (handler) {
              var promise = handler.trackEvent(properties);
              promises.push(promise);
            });

            return $q.all(promises);
          }
        }, {
          key: 'getAppId',
          value: function getAppId() {
            return self.appId;
          }
        }, {
          key: 'isVirtualPageTracking',
          value: function isVirtualPageTracking() {
            return self.virtualPageTracking;
          }
        }, {
          key: 'trackPageView',
          value: function trackPageView(url) {

            var promises = [];

            _angular2.default.forEach(this.services, function (handler) {
              var promise = handler.trackPageView(url);
              promises.push(promise);
            });

            return $q.all(promises);
          }
        }]);

        return AvAnalytics;
      }();

      return new AvAnalytics();
    }
  }]);

  return AvAnalyticsProvider;
}();

_module2.default.provider('avAnalytics', AvAnalyticsProvider);

exports.default = _module2.default;