'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OrganizationResourceFactory = function OrganizationResourceFactory(AvApiResource, avUsersResource) {
  var OrganizationResource = function (_AvApiResource) {
    _inherits(OrganizationResource, _AvApiResource);

    function OrganizationResource() {
      _classCallCheck(this, OrganizationResource);

      return _possibleConstructorReturn(this, (OrganizationResource.__proto__ || Object.getPrototypeOf(OrganizationResource)).call(this, {
        path: '/api/sdk/platform',
        name: 'organizations'
      }));
    }

    _createClass(OrganizationResource, [{
      key: 'afterQuery',
      value: function afterQuery(response) {
        return response.data.organizations || [];
      }
    }, {
      key: 'queryOrganizations',
      value: function queryOrganizations(user, config) {

        var params = {
          params: {
            userId: user.id
          }
        };

        // merge in params with user ID
        var queryConfig = _angular2.default.merge({}, params, config);

        return this.query(queryConfig);
      }
    }, {
      key: 'getOrganizations',
      value: function getOrganizations(config) {

        var self = this;

        return avUsersResource.me().then(function (user) {
          return self.queryOrganizations.call(self, user, config);
        });
      }
    }]);

    return OrganizationResource;
  }(AvApiResource);

  return new OrganizationResource();
};

_module2.default.factory('avOrganizationsResource', OrganizationResourceFactory);

exports.default = _module2.default;