'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _lodash = require('lodash.isregexp');

var _lodash2 = _interopRequireDefault(_lodash);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AvLocalStorageService = function () {
  function AvLocalStorageService($window) {
    _classCallCheck(this, AvLocalStorageService);

    this.$window = $window;
    this.hasSupport;
  }

  _createClass(AvLocalStorageService, [{
    key: 'supportsLocalStorage',
    value: function supportsLocalStorage() {

      if (!this.hasSupport) {

        var hasSupport = false;
        try {

          var localStorage = this.$window.localStorage;
          if (localStorage) {
            var uid = (0, _moment2.default)().unix();

            localStorage.setItem(uid, uid);
            var testVal = localStorage.getItem(uid);
            hasSupport = testVal === uid.toString();

            localStorage.removeItem(uid);
          }
        } catch (e) {
          hasSupport = false;
        }

        this.hasSupport = hasSupport;
      }
      return this.hasSupport;
    }
  }, {
    key: 'getVal',
    value: function getVal(key) {
      if (this.supportsLocalStorage()) {
        return this.$window.localStorage.getItem(key);
      }
    }
  }, {
    key: 'getObjVal',
    value: function getObjVal(key) {
      var rawVal = this.getVal(key);
      return rawVal ? rawVal : JSON.parse(rawVal);
    }
  }, {
    key: 'setVal',
    value: function setVal(key, value) {
      if (this.supportsLocalStorage()) {
        this.$window.localStorage.setItem(key, value);
      }
    }
  }, {
    key: 'removeVal',
    value: function removeVal(key) {
      if (this.supportsLocalStorage()) {
        this.$window.localStorage.removeItem(key);
      }
    }
  }, {
    key: 'removeKeys',
    value: function removeKeys(searchKey) {
      var _this = this;

      if (this.supportsLocalStorage()) {

        var regexString = (0, _lodash2.default)(searchKey) ? searchKey : new RegExp(searchKey);
        if (regexString) {

          var removeKeys = [];
          var length = this.$window.localStorage.length;
          for (var i = 0; i < length; i++) {
            var thisKey = this.$window.localStorage.key(i);
            if (regexString.test(thisKey)) {
              removeKeys.push(thisKey);
            }
          }

          removeKeys.forEach(function (key) {
            _this.removeVal(key);
          });
        }
      }
    }
  }]);

  return AvLocalStorageService;
}();

AvLocalStorageService.$inject = ['$window'];


_constants2.default.service('avLocalStorageService', AvLocalStorageService);

exports.default = _constants2.default;