'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// https://github.com/kylewelsby/angular-post-message/blob/master/src/angular-post-message.js
var AvMessageProvider = function () {
  function AvMessageProvider() {
    _classCallCheck(this, AvMessageProvider);

    this.enabled = true;
  }

  _createClass(AvMessageProvider, [{
    key: 'enable',
    value: function enable(value) {

      if (arguments.length) {
        this.enabled = !!value;
      }

      return this.enabled;
    }
  }, {
    key: '$get',
    value: function $get($rootScope, $log, AV_MESSAGES) {

      var that = this;

      var AvMessages = function () {
        function AvMessages() {
          var _this = this;

          _classCallCheck(this, AvMessages);

          this.onResize = (0, _lodash2.default)(function () {

            var height = (0, _jquery2.default)('html').height();
            _this.send({
              event: AV_MESSAGES.EVENTS.AV_RESIZE,
              height: height
            });
          }, AV_MESSAGES.RESIZE_DEBOUNCE);
        }

        _createClass(AvMessages, [{
          key: 'init',
          value: function init() {

            var $window = (0, _jquery2.default)(window);

            $window.on(AV_MESSAGES.EVENTS.MESSAGE, this.onMessage.bind(this));

            $window.on(AV_MESSAGES.EVENTS.RESIZE, this.onResize.bind(this));

            $window.on(AV_MESSAGES.EVENTS.UNLOAD, this.onUnload.bind(this));

            $rootScope.$on('$destroy', this.destroy.bind(this));
          }
        }, {
          key: 'destroy',
          value: function destroy() {

            (0, _jquery2.default)(window).off(AV_MESSAGES.EVENTS.MESSAGE);
            (0, _jquery2.default)(window).off(AV_MESSAGES.EVENTS.RESIZE);
            (0, _jquery2.default)(window).off(AV_MESSAGES.EVENTS.UNLOAD);
          }
        }, {
          key: 'onUnload',
          value: function onUnload() {

            this.send({
              event: AV_MESSAGES.EVENTS.UNLOAD
            });
          }
        }, {
          key: 'isDomain',
          value: function isDomain(url) {

            if (AV_MESSAGES.DOMAIN.test(this.domain())) {
              return AV_MESSAGES.DOMAIN.test(url);
            }

            return AV_MESSAGES.LOCAL.test(url);
          }
        }, {
          key: 'isEnabled',
          value: function isEnabled() {
            return that.enabled;
          }
        }, {
          key: 'onMessage',
          value: function onMessage(_event) {

            var event = _event;

            event = event.originalEvent || event; // jQuery wraps in `originalEvent`

            if (!event && !event.data) {
              // no op
              return;
            }

            // don't process messages emitted from same window
            if (event.source === window) {
              return;
            }

            if (!this.isDomain(event.origin)) {
              $log.warn('avMessages rejected a cross domain message since it does not match an *.availity.com  or localhost');
              return;
            }

            var data = event.data;

            try {
              data = _angular2.default.fromJson(data);
            } catch (err) {
              $log.warn('avMessages.onMessage() failed to convert event to json payload');
            }

            if (_angular2.default.isString(data)) {
              event = data;
              data = null;
            } else {
              event = data.event ? data.event : AV_MESSAGES.AV_RECEIVED;
            }

            $rootScope.$root.$broadcast(event, data);
          }
        }, {
          key: 'isIframe',
          value: function isIframe() {
            return window.self !== window.parent;
          }
        }, {
          key: 'domain',
          value: function domain() {

            if (window.location.origin) {
              return window.location.origin;
            }

            if (window.location.hostname) {
              return window.location.protocol + '//' + window.location.hostname + (window.location.port ? ':' + window.location.port : '');
            }

            return '*';
          }
        }, {
          key: 'send',
          value: function send(payload) {

            try {

              var message = _angular2.default.isString(payload) ? payload : JSON.stringify(payload);
              this.postMessage(message, this.domain());
            } catch (err) {
              $log.error('avMessages.send() ', err);
            }
          }
        }, {
          key: 'postMessage',
          value: function postMessage(message, domain) {
            window.parent.postMessage(message, domain);
          }
        }]);

        return AvMessages;
      }();

      return new AvMessages();
    }
  }]);

  return AvMessageProvider;
}();

_module2.default.provider('avMessages', AvMessageProvider);

_module2.default.run(function (avMessages) {

  if (avMessages.isEnabled()) {
    avMessages.init();
  }
});