'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function hasDateInput() {
  var i = document.createElement('input');
  i.setAttribute('type', 'date');
  return i.type !== 'text';
}

var hasDateInputSupport = hasDateInput();

// Inspiration https://github.com/mgcrea/angular-strap/blob/v0.7.8/src/directives/datepicker.js

var AvDatepickerController = function () {
  function AvDatepickerController($element, $attrs, AV_DATEPICKER, $scope, avDatepickerConfig) {
    _classCallCheck(this, AvDatepickerController);

    this.hasDateInputSupport = hasDateInputSupport;

    this.av = { $element: $element, $attrs: $attrs, AV_DATEPICKER: AV_DATEPICKER, $scope: $scope, avDatepickerConfig: avDatepickerConfig };
  }

  _createClass(AvDatepickerController, [{
    key: 'setValue',
    value: function setValue() {

      var viewValue = this.ngModel.$viewValue;
      var plugin = this.plugin();

      if (!viewValue || !plugin) {
        return;
      }

      plugin.setDate(viewValue);
    }
  }, {
    key: 'setNgModel',
    value: function setNgModel(ngModel) {
      this.ngModel = ngModel;
    }
  }, {
    key: 'findModel',
    value: function findModel() {

      var ngModel = null;

      var $input = this.av.$element.find('input:first').andSelf();
      if ($input.length) {
        ngModel = $input.data(this.av.AV_DATEPICKER.CONTROLLER);
        this.setNgModel(ngModel);
      }

      return ngModel;
    }
  }, {
    key: 'modelToView',
    value: function modelToView(modelValue) {
      var viewValue = _jquery2.default.fn.datepicker.DPGlobal.formatDate(modelValue, this.options.format, 'en');
      return viewValue;
    }
  }, {
    key: 'viewToModel',
    value: function viewToModel(viewValue) {

      var plugin = this.plugin();

      if (!plugin || !viewValue || viewValue === '') {
        return null;
      }

      var isValid = (0, _moment2.default)(viewValue, this.options._format, true).isValid();
      if (!isValid) {
        return undefined;
      }

      var format = _jquery2.default.fn.datepicker.DPGlobal.parseFormat(this.options.format);
      var utcDate = _jquery2.default.fn.datepicker.DPGlobal.parseDate(this.ngModel.$viewValue, format, 'en');

      var localDate = plugin._utc_to_local(utcDate);

      return localDate;
    }
  }, {
    key: 'init',
    value: function init() {
      var _this = this;

      var self = this;

      this.options = _angular2.default.copy(this.av.avDatepickerConfig);

      Object.keys(this.av.$attrs).forEach(function (key) {
        var value = self.av.$attrs[key];
        var _key = key.replace('data-', '');
        if (_this.av.AV_DATEPICKER.OPTIONS.indexOf(_key) >= 0) {
          self.options[_key] = self.av.$scope.$eval(value);
        }
      });

      this.convertFormat();
    }

    // Developers are used to working with moment.js and availity-angular
    // validators also use moment.js so this function converts from moment.js
    // to bootstrap-datepicker.js format.
    //
    // bootstrap-datepicker date format supports a combination of d, dd, D, DD, m, mm, M, MM, yy, yyyy.
    // Below is the conversion table from moment.js format options to bootstrap-datepicker.
    //
    // Moment formatting options:
    //
    //  - DD => 01 02 ... 30 31
    //  - D => 1 2 ... 30 31
    //  - M => 1 2 ... 11 12
    //  - MM => 01 02 ... 11 12
    //  - MMM => Jan Feb ... Nov Dec
    //  - MMMM => January February ... November December
    //  - YY => 70 71 ... 29 30
    //  - YYYY => 1970 1971 ... 2029 2030
    //
    //  Table reads moment.js format => bootstrap-datepicker format
    //
    //  - D, DD => d, dd: Numeric date, no leading zero and leading zero, respectively. Eg, 5, 05.
    //  - ddd, dddd => D, DD: Abbreviated and full weekday names, respectively. Eg, Mon, Monday.
    //  - M, MM => m, mm: Numeric month, no leading zero and leading zero, respectively. Eg, 7, 07.
    //  - MMM, MMMM => M, MM: Abbreviated and full month names, respectively. Eg, Jan, January
    //  - YY, YYYY => yy, yyyy: 2- and 4-digit years, respectively. Eg, 12, 2012.
    //

  }, {
    key: 'convertFormat',
    value: function convertFormat() {

      var format = this.options.format;
      this.options._format = this.options.format; // store orginal Moment format

      if (format) {

        // lower case everything
        format = format.toLowerCase();

        // Since we lowercased everything convert the map is slightly different than above
        var map = { 'mmm': 'M', 'mmmm': 'MM', 'ddd': 'D', 'dddd': 'DD' };
        var re = new RegExp(Object.keys(map).join('|'), 'gi');
        format = format.replace(re, function (matched) {
          return map[matched];
        });
      }

      // this is moment format converted to bootstrap-datepicker.js format.
      this.options.format = format;
    }
  }, {
    key: 'plugin',
    value: function plugin() {
      return this.av.$element.data('datepicker');
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      var plugin = this.plugin();
      if (plugin) {
        plugin.destroy();
        this.av.$element.data('datepicker', null);
      }
    }
  }, {
    key: 'hide',
    value: function hide() {
      var plugin = this.plugin();
      if (plugin) {
        plugin.hide();
      }
    }
  }]);

  return AvDatepickerController;
}();

_module2.default.controller('AvDatepickerController', AvDatepickerController);