'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AvDimmerController = function () {
  function AvDimmerController($scope, $element, avDimmerConfig) {
    _classCallCheck(this, AvDimmerController);

    this.av = { $scope: $scope, $element: $element, avDimmerConfig: avDimmerConfig };

    this.config = _angular2.default.extend({}, this.av.avDimmerConfig, this.av.$scope.avDimmerConfig || {});
  }

  _createClass(AvDimmerController, [{
    key: 'show',
    value: function show() {
      this.av.$element.find(this.config.overlaySelector).velocity('stop', true).velocity(this.config.showAnimation, this.config.animationConfig);
    }
  }, {
    key: 'hide',
    value: function hide() {
      this.av.$element.find(this.config.overlaySelector).velocity(this.config.hideAnimation, this.config.animationConfig);
    }
  }, {
    key: 'createListeners',
    value: function createListeners() {
      this.av.$element.on(this.config.showEvent, this.show.bind(this));
      this.av.$element.on(this.config.hideEvent, this.hide.bind(this));
    }
  }, {
    key: 'destroyListeners',
    value: function destroyListeners() {
      this.av.$element.off(this.config.showEvent, this.show.bind(this));
      this.av.$element.off(this.config.hideEvent, this.hide.bind(this));
    }
  }, {
    key: '$onChanges',
    value: function $onChanges(changesObj) {

      if (changesObj && changesObj.avDimmerConfig) {
        var newConfig = _angular2.default.extend({}, this.av.avDimmerConfig, changesObj.avDimmerConfig.currentValue);

        var resetListeners = !_angular2.default.equals(this.config.showEvent, newConfig.showEvent) || !_angular2.default.equals(this.config.hideEvent, newConfig.hideEvent);

        if (resetListeners) {
          this.destroyListeners();
        }

        this.config = newConfig;

        if (resetListeners) {
          this.createListeners();
        }
      }
    }
  }, {
    key: '$onInit',
    value: function $onInit() {
      this.createListeners();
    }
  }, {
    key: '$destroy',
    value: function $destroy() {
      this.destroyListeners();
    }
  }]);

  return AvDimmerController;
}();

exports.default = AvDimmerController;