'use strict';

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

var _uploadProgressBar = require('./upload-progress-bar.html');

var _uploadProgressBar2 = _interopRequireDefault(_uploadProgressBar);

var _templatePasswordPrompt = require('./template-password-prompt.html');

var _templatePasswordPrompt2 = _interopRequireDefault(_templatePasswordPrompt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_module2.default.directive('avUploadProgressBar', function (AvModal) {
  return {
    restrict: 'E',
    scope: {
      modal: '=',
      upload: '=',
      errorcallback: '='
    },
    templateUrl: _uploadProgressBar2.default,
    link: function link(scope, modal) {
      scope.showModal = function () {
        var focus = function focus() {
          var input = document.querySelector('.password-modal .modal-body input');
          if (input) {
            input.focus();
          }
        };

        modal = new AvModal({
          scope: scope,
          templateUrl: _templatePasswordPrompt2.default,
          onShown: focus
        });
      };

      scope.verifyPassword = function () {
        modal.hide();
        scope.upload.sendPassword(scope.upload.password);
      };
      scope.percentage = 0;

      var update = function update() {
        scope.error = false;
        scope.percentage = scope.upload.percentage;
      };

      var error = function error() {
        scope.error = true;
        return scope.errorcallback(scope.upload);
      };

      var success = function success() {
        scope.error = false;
        scope.percentage = 100;
      };

      scope.upload.onProgress.push(function () {
        return scope.$applyAsync(update);
      });
      scope.upload.onSuccess.push(function () {
        return scope.$applyAsync(success);
      });
      scope.upload.onError.push(function () {
        return scope.$applyAsync(error);
      });
    }
  };
});